- MongoDB C Driver 1.9.3-dev »
- API Reference »
- mongoc_gridfs_t

# mongoc_gridfs_find_one_with_opts()

## Synopsis

    mongoc_gridfs_file_t *
    mongoc_gridfs_find_one_with_opts (mongoc_gridfs_t *gridfs,
                                      const bson_t *filter,
                                      const bson_t *opts,
                                      bson_error_t *error)
       BSON_GNUC_WARN_UNUSED_RESULT;

## Parameters

- `gridfs`: A mongoc_gridfs_t.
- `filter`: A `bson_t` containing the query to execute.
- `opts`: A `bson_t` query options, including sort order and which fields to return. Can be `NULL`.
- `error`: An optional location for a bson_error_t or `NULL`.

## Description

Find the first GridFS file matching `filter`.

See mongoc_collection_find_with_opts() for a description of the `filter` and `opts` parameters.

## Errors

Errors are propagated via the `error` parameter.

## Returns

A newly allocated mongoc_gridfs_file_t or `NULL` if no file could be found. You must free the resulting file with mongoc_gridfs_file_destroy() if non-NULL.

Created using Sphinx 1.6.6, based on Sphinx Readable Theme.